package com.spectus.iap.spectus_in_app_purchase

import android.app.Activity
import android.content.Context
import android.content.Intent
import android.os.Handler
import android.util.Log
import androidx.annotation.NonNull
import io.flutter.embedding.engine.plugins.FlutterPlugin
import io.flutter.embedding.engine.plugins.activity.ActivityAware
import io.flutter.embedding.engine.plugins.activity.ActivityPluginBinding
import io.flutter.plugin.common.MethodCall
import io.flutter.plugin.common.MethodChannel
import io.flutter.plugin.common.MethodChannel.MethodCallHandler
import io.flutter.plugin.common.MethodChannel.Result
import io.flutter.plugin.common.PluginRegistry
import io.flutter.plugin.common.PluginRegistry.Registrar


/** SpectusInAppPurchasePlugin */
class SpectusInAppPurchasePlugin: FlutterPlugin, MethodCallHandler, ActivityAware, PluginRegistry.ActivityResultListener{

 // private lateinit var channel : MethodChannel
  var helper : IAPHelper? = null
  var productID : String? = ""
  var mContext1 : Context? = null
  var mActivity : Activity? = null
  var mContext : Context? = null
  var operationResult : Result? = null
    var productArray : ArrayList<Map<String, String>> = arrayListOf()
    var isCalling = false

    override fun onDetachedFromActivity() {
        //
    }

    override fun onReattachedToActivityForConfigChanges(binding: ActivityPluginBinding) {
        onAttachedToActivity(binding)
    }

    override fun onAttachedToActivity(binding: ActivityPluginBinding) {
        Log.e("onAttachedToActivity","Called")
        if(binding.activity == null){
            Log.e("binding.activity","null")
        }
        mActivity = binding.activity
        binding.addActivityResultListener(this)
    }

    override fun onDetachedFromActivityForConfigChanges() {
        TODO("Not yet implemented")
    }

    override fun onAttachedToEngine(@NonNull flutterPluginBinding: FlutterPlugin.FlutterPluginBinding) {
    val channel = MethodChannel(flutterPluginBinding.getFlutterEngine().getDartExecutor(), "spectus_in_app_purchase")
    mContext = flutterPluginBinding.applicationContext
    //mContext = mContext1 as Activity
    channel.setMethodCallHandler(this)
  }

  companion object {
    @JvmStatic
    fun registerWith(registrar: Registrar) {
      val channel = MethodChannel(registrar.messenger(), "spectus_in_app_purchase")
      channel.setMethodCallHandler(SpectusInAppPurchasePlugin())
      //helper = IAPHelper()
    }
  }

  override fun onMethodCall(@NonNull call: MethodCall, @NonNull result: Result) {

      android.util.Log.e("onMethodCall"," "+call.method)

    if (call.method == "getPlatformVersion") {
      result.success("Android ${android.os.Build.VERSION.RELEASE}")
    }
    else if (call.method == "getSKUProductListWith") {
        productID = call.argument<String>("productID")
        // context = call.argument<Context>("context")
        operationResult = result
        android.util.Log.e("Productid"," "+productID)
        android.util.Log.e("helper"," "+helper)

        if(mActivity==null){
            Log.e("Mactivity","Null")
        }

//        this.productArray.removeAll()
        this.isCalling = false
        this.manageIAP()
    }
    else if (call.method == "startInAppPurchaseWith") {
      productID = call.argument<String>("productID")
     // context = call.argument<Context>("context")
      operationResult = result
     android.util.Log.e("Productid"," "+productID)
     android.util.Log.e("helper"," "+helper)

        if(mActivity==null){
            Log.e("Mactivity","Null")
        }

        IAPHelper().startInAppPurchaseWith(mActivity!!,
                mContext!!,
                productID!!,
                { error, purchaseObject, transactionID ->
        if (error != null) {
          operationResult!!.success("NA")
        }

        if (transactionID != null) {
            Log.e("PRODUCT ID ==>> ","" + transactionID)
          operationResult!!.success(transactionID)
        }
      })

      /*helper.startInAppPurchaseWith(mContext, productID, { error, purchaseObject, transactionID ->
        if (error != null) {
          operationResult!!.success("NA")
        }

        if (transactionID != null) {
          operationResult!!.success(transactionID)
        }
      })*/
    } else {
      result.notImplemented()
    }
  }

    fun manageIAP() {
        Log.e("STEP 1","manageIAP")
        Log.e("Operation Not Null","" + this.operationResult!!.toString())



            IAPHelper().getSKUProductListWith(mActivity!!,
                mContext!!,
                productID!!,
                { error, productsList ->
                    Log.e("Callback in Dart","")
                    if (error != null) {
                        var array : ArrayList<Map<String, String>> = arrayListOf()
                        Log.e("Inside Error Log","")
                        operationResult!!.error("1", "Array Empty", "NoDetails")
                    } else {
                        Log.e("Inside Product array","" + productsList.size.toString())
                        Log.e("Product Details Log","" + productsList[0].toString())
                        if (operationResult != null) {
                            Log.e("Operation Not Null","" + operationResult!!.toString())
//                        result.success(productsList)
//                        result.success("My List")
//                        result.error("2","No products found!", "NA")
                            Log.e("STEP 2","manageIAP")
                            this.productArray.addAll(productsList)
                            //this.returnResult()
                        } else {
                            Log.e("Operation is Null","")
                            operationResult!!.error("2","No products found!", "NA")
                        }
                    }
                })



        Log.e("STEP 3","manageIAP => " + this.productArray.size.toString())
        Log.e("Operation Not Null","" + this.operationResult!!.toString())

        Handler().postDelayed({
            Log.e("STEP 5","manageIAP")
            this.operationResult!!.success(this.productArray)
        }, 5000)
//        if (this.productArray.size == 0) {
//            Log.e("STEP 4","manageIAP")
//            this.manageIAP()
//        } else {
//            Log.e("STEP 5","manageIAP")
//            this.operationResult!!.success("productsList")
//        }
    }

    fun returnResult() {
        this.operationResult!!.success("productsList")
    }

  override fun onDetachedFromEngine(@NonNull binding: FlutterPlugin.FlutterPluginBinding) {
  //  channel.setMethodCallHandler(null)
  }

    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?): Boolean {
        //TODO("Not yet implemented")
        return  false
    }

    /*override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        //TODO("Not yet implemented")
    }*/
}
